VirtualBox

source: vbox/trunk/src/VBox/Installer/linux/vboxautostart-service.sh@ 58097

Last change on this file since 58097 was 57985, checked in by vboxsync, 9 years ago

Installers/linux: silence some unwanted output.

  • Property svn:eol-style set to LF
  • Property svn:keywords set to Author Date Id Revision
File size: 3.2 KB
Line 
1#!/bin/sh
2#
3# VirtualBox autostart service init script.
4#
5# Copyright (C) 2012-2015 Oracle Corporation
6#
7# This file is part of VirtualBox Open Source Edition (OSE), as
8# available from http://www.virtualbox.org. This file is free software;
9# you can redistribute it and/or modify it under the terms of the GNU
10# General Public License (GPL) as published by the Free Software
11# Foundation, in version 2 as it comes in the "COPYING" file of the
12# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
13# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
14#
15
16# chkconfig: 345 35 65
17# description: VirtualBox autostart service
18#
19### BEGIN INIT INFO
20# Provides: vboxautostart-service
21# Required-Start: vboxdrv
22# Required-Stop: vboxdrv
23# Default-Start: 2 3 4 5
24# Default-Stop: 0 1 6
25# Description: VirtualBox autostart service
26### END INIT INFO
27
28PATH=$PATH:/bin:/sbin:/usr/sbin
29SCRIPTNAME=vboxautostart-service
30
31[ -f /etc/debian_release -a -f /lib/lsb/init-functions ] || NOLSB=yes
32[ -f /etc/vbox/vbox.cfg ] && . /etc/vbox/vbox.cfg
33
34if [ -n "$INSTALL_DIR" ]; then
35 binary="$INSTALL_DIR/VBoxAutostart"
36else
37 binary="/usr/lib/virtualbox/VBoxAutostart"
38fi
39
40# silently exit if the package was uninstalled but not purged,
41# applies to Debian packages only (but shouldn't hurt elsewhere)
42[ ! -f /etc/debian_release -o -x $binary ] || exit 0
43
44[ -r /etc/default/virtualbox ] && . /etc/default/virtualbox
45
46# Preamble for Gentoo
47if [ "`which $0`" = "/sbin/rc" ]; then
48 shift
49fi
50
51begin_msg()
52{
53 test -n "${2}" && echo "${SCRIPTNAME}: ${1}."
54 logger "${SCRIPTNAME}: ${1}."
55}
56
57succ_msg()
58{
59 logger "${SCRIPTNAME}: done."
60}
61
62fail_msg()
63{
64 echo "${SCRIPTNAME}: failed: ${1}." >&2
65 logger "${SCRIPTNAME}: failed: ${1}."
66}
67
68start_daemon() {
69 usr="$1"
70 shift
71 su - $usr -c "$*"
72}
73
74if which start-stop-daemon >/dev/null 2>&1; then
75 start_daemon() {
76 usr="$1"
77 shift
78 bin="$1"
79 shift
80 start-stop-daemon --background --chuid $usr --start --exec $bin -- $@
81 }
82fi
83
84vboxdrvrunning() {
85 lsmod | grep -q "vboxdrv[^_-]"
86}
87
88start() {
89 [ -z "$VBOXAUTOSTART_DB" ] && exit 0
90 [ -z "$VBOXAUTOSTART_CONFIG" ] && exit 0
91 begin_msg "Starting VirtualBox VMs configured for autostart" console;
92 vboxdrvrunning || {
93 fail_msg "VirtualBox kernel module not loaded!"
94 exit 0
95 }
96 PARAMS="--background --start --config $VBOXAUTOSTART_CONFIG"
97
98 # prevent inheriting this setting to VBoxSVC
99 unset VBOX_RELEASE_LOG_DEST
100
101 for user in `ls $VBOXAUTOSTART_DB/*.start`
102 do
103 start_daemon `basename $user | sed -ne "s/\(.*\).start/\1/p"` $binary $PARAMS > /dev/null 2>&1
104 done
105
106 return $RETVAL
107}
108
109stop() {
110 [ -z "$VBOXAUTOSTART_DB" ] && exit 0
111 [ -z "$VBOXAUTOSTART_CONFIG" ] && exit 0
112
113 PARAMS="--stop --config $VBOXAUTOSTART_CONFIG"
114
115 # prevent inheriting this setting to VBoxSVC
116 unset VBOX_RELEASE_LOG_DEST
117
118 for user in `ls $VBOXAUTOSTART_DB/*.stop`
119 do
120 start_daemon `basename $user | sed -ne "s/\(.*\).stop/\1/p"` $binary $PARAMS > /dev/null 2>&1
121 done
122
123 return $RETVAL
124}
125
126case "$1" in
127start)
128 start
129 ;;
130stop)
131 stop
132 ;;
133*)
134 echo "Usage: $0 {start|stop}"
135 exit 1
136esac
137
138exit $RETVAL
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use